diff --git a/js/src/devtools/gc/gc-test.py b/js/src/devtools/gc/gc-test.py
index dd2097804a..09d78f1293 100644
--- a/js/src/devtools/gc/gc-test.py
+++ b/js/src/devtools/gc/gc-test.py
@@ -4,6 +4,7 @@
 
 # Works with python2.6
 
+from __future__ import print_function
 import datetime, os, re, sys, traceback
 import math, string, copy, json
 import subprocess
@@ -82,20 +83,20 @@ def run_tests(tests, test_dir):
             fmt = '%20s: {"TMax": %4.1f, "TAvg": %4.1f, "MMax": %4.1f, "MAvg": %4.1f, "SMax": %4.1f, "SAvg": %4.1f}'
             if (i != len(tests) - 1):
                 fmt += ','
-            print(fmt %(filename_str ,TMax, TAvg, MMax, MAvg, SMax, MAvg))
+            print((fmt %(filename_str ,TMax, TAvg, MMax, MAvg, SMax, MAvg)))
     except KeyboardInterrupt:
         print('fail')
 
     return dict((filename, dict(TMax=TMax, TAvg=TAvg, MMax=MMax, MAvg=MAvg, SMax=SMax, SAvg=SAvg))
-            for filename, (TMax, TAvg, MMax, MAvg, SMax, SAvg) in bench_map.iteritems())
+            for filename, (TMax, TAvg, MMax, MAvg, SMax, SAvg) in bench_map.items())
 
 def compare(current, baseline):
     percent_speedups = []
-    for key, current_result in current.iteritems():
+    for key, current_result in current.items():
         try:
             baseline_result = baseline[key]
         except KeyError:
-            print key, 'missing from baseline'
+            print(key, 'missing from baseline')
             continue
 
         val_getter = itemgetter('TMax', 'TAvg', 'MMax', 'MAvg', 'SMax', 'SAvg')
@@ -113,9 +114,9 @@ def compare(current, baseline):
             result = 'SLOWER: %6.2f > baseline %6.2f (%+6.2f%%) ' % \
                     (CTAvg, BTAvg, slowdown)
             percent_speedups.append(slowdown)
-        print '%30s: %s' % (key, result)
+        print('%30s: %s' % (key, result))
     if percent_speedups:
-        print 'Average speedup: %.2f%%' % avg(percent_speedups)
+        print('Average speedup: %.2f%%' % avg(percent_speedups))
 
 if __name__ == '__main__':
     script_path = os.path.abspath(__file__)
@@ -141,7 +142,7 @@ if __name__ == '__main__':
     test_list = find_tests(test_dir)
 
     if not test_list:
-        print >> sys.stderr, "No tests found matching command line arguments."
+        print("No tests found matching command line arguments.", file=sys.stderr)
         sys.exit(0)
 
     test_list = [ Test.from_file(tst, name, OPTIONS) for tst, name in test_list ]
@@ -153,7 +154,7 @@ if __name__ == '__main__':
 
     except OSError:
         if not os.path.exists(JS):
-            print >> sys.stderr, "JS shell argument: file does not exist: '%s'"%JS
+            print("JS shell argument: file does not exist: '%s'"%JS, file=sys.stderr)
             sys.exit(1)
         else:
             raise
diff --git a/js/src/devtools/rootAnalysis/analyze.py b/js/src/devtools/rootAnalysis/analyze.py
index 69482dab7b..610d41f192 100755
--- a/js/src/devtools/rootAnalysis/analyze.py
+++ b/js/src/devtools/rootAnalysis/analyze.py
@@ -9,6 +9,7 @@
 Runs the static rooting analysis
 """
 
+from __future__ import print_function
 from subprocess import Popen
 import subprocess
 import os
@@ -61,7 +62,7 @@ def print_command(command, outfile=None, env=None):
                     outputs.append("%s='%s'" % (key, value))
             output = ' '.join(outputs) + " " + output
 
-    print output
+    print(output)
 
 def generate_hazards(config, outfilename):
     jobs = []
@@ -150,13 +151,13 @@ def out_indexes(command):
 
 def run_job(name, config):
     cmdspec, outfiles = JOBS[name]
-    print("Running " + name + " to generate " + str(outfiles))
+    print(("Running " + name + " to generate " + str(outfiles)))
     if hasattr(cmdspec, '__call__'):
         cmdspec(config, outfiles)
     else:
         temp_map = {}
         cmdspec = fill(cmdspec, config)
-        if isinstance(outfiles, basestring):
+        if isinstance(outfiles, str):
             stdout_filename = '%s.tmp' % name
             temp_map[stdout_filename] = outfiles
             if config['verbose']:
@@ -188,7 +189,7 @@ def run_job(name, config):
             try:
                 os.rename(temp, final)
             except OSError:
-                print("Error renaming %s -> %s" % (temp, final))
+                print(("Error renaming %s -> %s" % (temp, final)))
                 raise
 
 config = { 'ANALYSIS_SCRIPTDIR': os.path.dirname(__file__) }
@@ -224,9 +225,9 @@ args = parser.parse_args()
 
 for default in defaults:
     try:
-        execfile(default, config)
+        exec(compile(open(default, "rb").read(), default, 'exec'), config)
         if args.verbose:
-            print("Loaded %s" % default)
+            print(("Loaded %s" % default))
     except:
         pass
 
@@ -272,14 +273,14 @@ if args.list:
     for step in steps:
         command, outfilename = JOBS[step]
         if outfilename:
-            print("%s -> %s" % (step, outfilename))
+            print(("%s -> %s" % (step, outfilename)))
         else:
             print(step)
     sys.exit(0)
 
 for step in steps:
     command, outfiles = JOBS[step]
-    if isinstance(outfiles, basestring):
+    if isinstance(outfiles, str):
         data[step] = outfiles
     else:
         outfile = 0
diff --git a/js/src/devtools/rootAnalysis/explain.py b/js/src/devtools/rootAnalysis/explain.py
index dc8b76f5c6..54bcee53a2 100755
--- a/js/src/devtools/rootAnalysis/explain.py
+++ b/js/src/devtools/rootAnalysis/explain.py
@@ -1,5 +1,6 @@
 #!/usr/bin/python
 
+from __future__ import print_function
 import re
 import argparse
 
@@ -34,20 +35,20 @@ try:
             m = re.match(r'^Time: (.*)', line)
             mm = re.match(r'^Run on:', line)
             if m or mm:
-                print >>hazards, line
-                print >>extra, line
-                print >>refs, line
+                print(line, file=hazards)
+                print(line, file=extra)
+                print(line, file=refs)
                 continue
 
             m = re.match(r'^Function.*has unnecessary root', line)
             if m:
-                print >>extra, line
+                print(line, file=extra)
                 continue
 
             m = re.match(r'^Function.*takes unsafe address of unrooted', line)
             if m:
                 num_refs += 1
-                print >>refs, line
+                print(line, file=refs)
                 continue
 
             m = re.match(r"^Function.*has unrooted.*of type.*live across GC call ('?)(.*?)('?) at \S+:\d+$", line)
@@ -90,14 +91,14 @@ try:
             gcHazards = hazardousGCFunctions[gcFunction]
 
             if gcFunction in gcExplanations:
-                print >>hazards, (gcHazards[index] + gcExplanations[gcFunction])
+                print((gcHazards[index] + gcExplanations[gcFunction]), file=hazards)
             else:
-                print >>hazards, gcHazards[index]
+                print(gcHazards[index], file=hazards)
 
 except IOError as e:
-    print 'Failed: %s' % str(e)
+    print('Failed: %s' % str(e))
 
-print("Wrote %s" % args.hazards)
-print("Wrote %s" % args.extra)
-print("Wrote %s" % args.refs)
-print("Found %d hazards and %d unsafe references" % (num_hazards, num_refs))
+print(("Wrote %s" % args.hazards))
+print(("Wrote %s" % args.extra))
+print(("Wrote %s" % args.refs))
+print(("Found %d hazards and %d unsafe references" % (num_hazards, num_refs)))
diff --git a/js/src/devtools/rootAnalysis/run-test.py b/js/src/devtools/rootAnalysis/run-test.py
index 3bc9085a0a..fca7dedeeb 100644
--- a/js/src/devtools/rootAnalysis/run-test.py
+++ b/js/src/devtools/rootAnalysis/run-test.py
@@ -3,6 +3,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os
 import site
 import subprocess
@@ -85,5 +86,5 @@ for name in cfg.tests:
 
     os.chdir(outdir)
     subprocess.call(["sh", "-c", "rm *.xdb"])
-    execfile(os.path.join(indir, "test.py"), {'test': test, 'equal': equal})
-    print("TEST-PASSED: %s" % name)
+    exec(compile(open(os.path.join(indir, "test.py"), "rb").read(), os.path.join(indir, "test.py"), 'exec'), {'test': test, 'equal': equal})
+    print(("TEST-PASSED: %s" % name))
diff --git a/js/src/devtools/rootAnalysis/t/hazards/test.py b/js/src/devtools/rootAnalysis/t/hazards/test.py
index 3eb08aa09d..75c7bf720e 100644
--- a/js/src/devtools/rootAnalysis/t/hazards/test.py
+++ b/js/src/devtools/rootAnalysis/t/hazards/test.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 test.compile("source.cpp")
 test.run_analysis_script('gcTypes')
 
@@ -22,7 +23,7 @@ assert('<returnvalue>' in hazmap)
 
 # All hazards should be in f() and loopy()
 assert(hazmap['cell2'].function == 'Cell* f()')
-print(len(set(haz.function for haz in hazards)))
+print((len(set(haz.function for haz in hazards))))
 assert(len(set(haz.function for haz in hazards)) == 2)
 
 # Check that the correct GC call is reported for each hazard. (cell3 has a
diff --git a/js/src/devtools/rootAnalysis/t/suppression/test.py b/js/src/devtools/rootAnalysis/t/suppression/test.py
index 65974cc336..ad33411460 100644
--- a/js/src/devtools/rootAnalysis/t/suppression/test.py
+++ b/js/src/devtools/rootAnalysis/t/suppression/test.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 test.compile("source.cpp")
 test.run_analysis_script('gcTypes', upto='gcFunctions')
 
@@ -9,9 +10,9 @@ suppressed = test.load_suppressed_functions()
 
 # Only one of these is fully suppressed (ie, *always* called within the scope
 # of an AutoSuppressGC).
-assert(len(filter(lambda f: 'suppressedFunction' in f, suppressed)) == 1)
-assert(len(filter(lambda f: 'halfSuppressedFunction' in f, suppressed)) == 0)
-assert(len(filter(lambda f: 'unsuppressedFunction' in f, suppressed)) == 0)
+assert(len([f for f in suppressed if 'suppressedFunction' in f]) == 1)
+assert(len([f for f in suppressed if 'halfSuppressedFunction' in f]) == 0)
+assert(len([f for f in suppressed if 'unsuppressedFunction' in f]) == 0)
 
 # gcFunctions should be the inverse, but we get to rely on unmangled names here.
 gcFunctions = test.load_gcFunctions()
diff --git a/js/src/devtools/rootAnalysis/t/testlib.py b/js/src/devtools/rootAnalysis/t/testlib.py
index 438398f1ed..27d34d12f3 100644
--- a/js/src/devtools/rootAnalysis/t/testlib.py
+++ b/js/src/devtools/rootAnalysis/t/testlib.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 import json
 import os
 import re
@@ -13,7 +14,7 @@ HazardSummary = namedtuple('HazardSummary', ['function', 'variable', 'type', 'GC
 
 def equal(got, expected):
     if got != expected:
-        print("Got '%s', expected '%s'" % (got, expected))
+        print(("Got '%s', expected '%s'" % (got, expected)))
 
 def extract_unmangled(func):
     return func.split('$')[-1]
@@ -37,16 +38,16 @@ class Test(object):
             CXX=self.cfg.cxx, sixgill=self.cfg.sixgill_plugin,
             options=options)
         if self.cfg.verbose:
-            print("Running %s" % cmd)
+            print(("Running %s" % cmd))
         subprocess.check_call(["sh", "-c", cmd])
 
     def load_db_entry(self, dbname, pattern):
         '''Look up an entry from an XDB database file, 'pattern' may be an exact
         matching string, or an re pattern object matching a single entry.'''
 
-        if not isinstance(pattern, basestring):
+        if not isinstance(pattern, str):
             output = subprocess.check_output([self.binpath("xdbkeys"), dbname + ".xdb"])
-            matches = filter(lambda _: re.search(pattern, _), output.splitlines())
+            matches = [_ for _ in output.splitlines() if re.search(pattern, _)]
             if len(matches) == 0:
                 raise Exception("entry not found")
             if len(matches) > 1:
@@ -57,7 +58,7 @@ class Test(object):
         return json.loads(output)
 
     def run_analysis_script(self, phase, upto=None):
-        file("defaults.py", "w").write('''\
+        open("defaults.py", "w").write('''\
 analysis_scriptdir = '{scriptdir}'
 sixgill_bin = '{bindir}'
 '''.format(scriptdir=scriptdir, bindir=self.cfg.sixgill_bin))
@@ -69,7 +70,7 @@ sixgill_bin = '{bindir}'
         cmd.append("--js=%s" % self.cfg.js)
         if self.cfg.verbose:
             cmd.append("--verbose")
-            print("Running " + " ".join(cmd))
+            print(("Running " + " ".join(cmd)))
         subprocess.check_call(cmd)
 
     def computeGCTypes(self):
@@ -80,8 +81,8 @@ sixgill_bin = '{bindir}'
 
     def load_text_file(self, filename, extract=lambda l: l):
         fullpath = os.path.join(self.outdir, filename)
-        values = (extract(line.strip()) for line in file(fullpath))
-        return filter(lambda _: _ is not None, values)
+        values = (extract(line.strip()) for line in open(fullpath))
+        return [_ for _ in values if _ is not None]
 
     def load_suppressed_functions(self):
         return set(self.load_text_file("suppressedFunctions.lst"))
diff --git a/js/src/frontend/GenerateReservedWords.py b/js/src/frontend/GenerateReservedWords.py
index bd698cc5f0..8095a9d4df 100644
--- a/js/src/frontend/GenerateReservedWords.py
+++ b/js/src/frontend/GenerateReservedWords.py
@@ -80,14 +80,14 @@ def split_list_per_column(reserved_word_list, column):
         per_column = column_dict.setdefault(word[column], [])
         per_column.append(item)
 
-    return sorted(column_dict.items(), key=lambda (char, word): ord(char))
+    return sorted(list(column_dict.items()), key=lambda char_word: ord(char_word[0]))
 
 def generate_letter_switch(opt, unprocessed_columns, reserved_word_list,
                            columns=None):
     assert(len(reserved_word_list) != 0);
 
     if not columns:
-        columns = range(0, unprocessed_columns)
+        columns = list(range(0, unprocessed_columns))
 
     if len(reserved_word_list) == 1:
         index, word = reserved_word_list[0]
@@ -161,7 +161,7 @@ def split_list_per_length(reserved_word_list):
         per_length = length_dict.setdefault(len(word), [])
         per_length.append(item)
 
-    return sorted(length_dict.items(), key=lambda (length, word): length)
+    return sorted(list(length_dict.items()), key=lambda length_word: length_word[0])
 
 def generate_switch(opt, reserved_word_list):
     assert(len(reserved_word_list) != 0);
diff --git a/js/src/gdb/mozilla/ExecutableAllocator.py b/js/src/gdb/mozilla/ExecutableAllocator.py
index e1ff812403..4ebe31a49b 100644
--- a/js/src/gdb/mozilla/ExecutableAllocator.py
+++ b/js/src/gdb/mozilla/ExecutableAllocator.py
@@ -62,7 +62,7 @@ class jsjitExecutableAllocator(object):
             self.index = self.index + 1
             if self.table[cur]['keyHash'] > 1: # table[i]->isLive()
                 return self.table[cur]['mem']['u']['mDummy'].cast(self.entryType)
-            return self.next()
+            return next(self)
 
 @ptr_pretty_printer("js::jit::ExecutablePool")
 class jsjitExecutablePool(mozilla.prettyprinters.Pointer):
diff --git a/js/src/gdb/mozilla/JSString.py b/js/src/gdb/mozilla/JSString.py
index 99d5ce987d..7c60d8e2ac 100644
--- a/js/src/gdb/mozilla/JSString.py
+++ b/js/src/gdb/mozilla/JSString.py
@@ -3,6 +3,7 @@
 import gdb
 import mozilla.prettyprinters
 from mozilla.prettyprinters import pretty_printer, ptr_pretty_printer
+unichr = chr
 
 try:
     chr(10000) # UPPER RIGHT PENCIL
diff --git a/js/src/gdb/mozilla/asmjs.py b/js/src/gdb/mozilla/asmjs.py
index 43fac20c73..c6d742abd9 100644
--- a/js/src/gdb/mozilla/asmjs.py
+++ b/js/src/gdb/mozilla/asmjs.py
@@ -3,6 +3,7 @@ In asm code, out-of-bounds heap accesses cause segfaults, which the engine
 handles internally. Make GDB ignore them.
 """
 
+from __future__ import print_function
 import gdb
 
 SIGSEGV = 11
diff --git a/js/src/gdb/mozilla/autoload.py b/js/src/gdb/mozilla/autoload.py
index 43cbcdf721..0acb2dd484 100644
--- a/js/src/gdb/mozilla/autoload.py
+++ b/js/src/gdb/mozilla/autoload.py
@@ -1,5 +1,6 @@
 # mozilla/autoload.py: Autoload SpiderMonkey pretty-printers.
 
+from __future__ import print_function
 print("Loading JavaScript value pretty-printers; see js/src/gdb/README.")
 print("If they cause trouble, type: disable pretty-printer .* SpiderMonkey")
 
diff --git a/js/src/gdb/mozilla/unwind.py b/js/src/gdb/mozilla/unwind.py
index adea63ea6c..73036a4d6f 100644
--- a/js/src/gdb/mozilla/unwind.py
+++ b/js/src/gdb/mozilla/unwind.py
@@ -10,14 +10,14 @@ from mozilla.ExecutableAllocator import jsjitExecutableAllocatorCache, jsjitExec
 # For ease of use in Python 2, we use "long" instead of "int"
 # everywhere.
 try:
-    long
+    int
 except NameError:
     long = int
 
 # The Python 3 |map| built-in works lazily, but in Python 2 we need
 # itertools.imap to get this.
 try:
-    from itertools import imap
+    
 except ImportError:
     imap = map
 
@@ -66,7 +66,7 @@ class UnwinderTypeCache(object):
         return self.d[name]
 
     def value(self, name):
-        return long(gdb.parse_and_eval('js::jit::' + name))
+        return int(gdb.parse_and_eval('js::jit::' + name))
 
     def initialize(self):
         self.d = {}
@@ -94,7 +94,7 @@ class UnwinderTypeCache(object):
         self.d['JSScript'] = gdb.lookup_type("JSScript").pointer()
         self.d['Value'] = gdb.lookup_type("JS::Value")
 
-        self.d['SOURCE_SLOT'] = long(gdb.parse_and_eval('js::ScriptSourceObject::SOURCE_SLOT'))
+        self.d['SOURCE_SLOT'] = int(gdb.parse_and_eval('js::ScriptSourceObject::SOURCE_SLOT'))
         self.d['NativeObject'] = gdb.lookup_type("js::NativeObject").pointer()
         self.d['HeapSlot'] = gdb.lookup_type("js::HeapSlot").pointer()
         self.d['ScriptSource'] = gdb.lookup_type("js::ScriptSource").pointer()
@@ -105,7 +105,7 @@ class UnwinderTypeCache(object):
         for field in t.fields():
             # Strip off "js::jit::".
             name = field.name[9:]
-            enumval = long(field.enumval)
+            enumval = int(field.enumval)
             self.d[name] = enumval
             self.frame_enum_names[enumval] = name
             class_type = gdb.lookup_type('js::jit::' + SizeOfFramePrefix[name])
@@ -134,7 +134,7 @@ def parse_proc_maps():
             if name is '' or (name.startswith('[') and name is not '[vdso]'):
                 # Skip entries not corresponding to a file.
                 continue
-            mappings.append((long(start, 16), long(end, 16)))
+            mappings.append((int(start, 16), int(end, 16)))
     return mappings
 
 # A symbol/value pair as expected from gdb frame decorators.
@@ -159,7 +159,7 @@ class JitFrameDecorator(FrameDecorator):
         self.cache = cache
 
     def _decode_jitframe(self, this_frame):
-        calleetoken = long(this_frame['calleeToken_'])
+        calleetoken = int(this_frame['calleeToken_'])
         tag = calleetoken & 3
         calleetoken = calleetoken ^ tag
         function = None
@@ -224,7 +224,7 @@ class JitFrameDecorator(FrameDecorator):
             return FrameDecorator.frame_args(self)
         # Construct and return an iterable of all the arguments.
         result = []
-        num_args = long(this_frame["numActualArgs_"])
+        num_args = int(this_frame["numActualArgs_"])
         # Sometimes we see very large values here, so truncate it to
         # bypass the damage.
         if num_args > 10:
@@ -263,7 +263,7 @@ class SpiderMonkeyFrameFilter(object):
         return JitFrameDecorator(frame, info, self.cache)
 
     def filter(self, frame_iter):
-        return imap(self.maybe_wrap_frame, frame_iter)
+        return map(self.maybe_wrap_frame, frame_iter)
 
 # A frame id class, as specified by the gdb unwinder API.
 class SpiderMonkeyFrameId(object):
@@ -306,7 +306,7 @@ class UnwinderState(object):
     # Otherwise, return None.  This is used by the frame filter to
     # display extra information about the frame.
     def get_frame(self, frame):
-        sp = long(frame.read_register(self.SP_REGISTER))
+        sp = int(frame.read_register(self.SP_REGISTER))
         if sp in self.frame_map:
             return self.frame_map[sp]
         return None
@@ -315,7 +315,7 @@ class UnwinderState(object):
     # queried by |self.get_frame|.  |sp| is the frame's stack pointer,
     # and |name| the frame's type as a string, e.g. "JitFrame_Exit".
     def add_frame(self, sp, name = None, this_frame = None):
-        self.frame_map[long(sp)] = { "name": name, "this_frame": this_frame }
+        self.frame_map[int(sp)] = { "name": name, "this_frame": this_frame }
 
     # See whether |pc| is claimed by some text mapping.  See
     # |parse_proc_maps| for details on how the decision is made.
@@ -362,12 +362,12 @@ class UnwinderState(object):
     # the size of this frame's header; and |frame_type| is an integer
     # representing the previous frame's type.
     def unpack_descriptor(self, common):
-        value = long(common['descriptor_'])
+        value = int(common['descriptor_'])
         local_size = value >> self.typecache.FRAMESIZE_SHIFT
         header_size = ((value >> self.typecache.FRAME_HEADER_SIZE_SHIFT) &
                        self.typecache.FRAME_HEADER_SIZE_MASK)
         header_size = header_size * self.typecache.void_starstar.sizeof
-        frame_type = long(value & self.typecache.FRAMETYPE_MASK)
+        frame_type = int(value & self.typecache.FRAMETYPE_MASK)
         if frame_type == self.typecache.JitFrame_Entry:
             # Trampoline-x64.cpp pushes a JitFrameLayout object, but
             # the stack pointer is actually adjusted as if a
@@ -470,7 +470,7 @@ class UnwinderState(object):
 
         # If the jit does not claim this address, bail.  GDB defers to our
         # unwinder by default, but we don't really want that kind of power.
-        if not self.is_jit_address(long(pc)):
+        if not self.is_jit_address(int(pc)):
             return None
 
         if self.next_sp is not None:
diff --git a/js/src/gdb/run-tests.py b/js/src/gdb/run-tests.py
index 1e4f4783b0..b341b9dbc3 100644
--- a/js/src/gdb/run-tests.py
+++ b/js/src/gdb/run-tests.py
@@ -5,6 +5,7 @@
 
 # run-tests.py -- Python harness for GDB SpiderMonkey support
 
+from __future__ import print_function
 import os, re, subprocess, sys, traceback
 from threading import Thread
 
@@ -104,7 +105,7 @@ class Summary(object):
 
         if self.failures:
 
-            print "tests failed:"
+            print("tests failed:")
             for test in self.failures:
                 test.show(sys.stdout)
 
@@ -129,7 +130,7 @@ class Summary(object):
                     sys.exit(1)
 
         if self.timeouts:
-            print "tests timed out:"
+            print("tests timed out:")
             for test in self.timeouts:
                 test.show(sys.stdout)
 
@@ -187,7 +188,7 @@ class Test(TaskPool.Task):
         self.summary.timeout(self)
 
     def show_cmd(self, out):
-        print "Command: ", make_shell_cmd(self.cmd())
+        print("Command: ", make_shell_cmd(self.cmd()))
 
     def show_output(self, out):
         if self.stdout:
diff --git a/js/src/gdb/taskpool.py b/js/src/gdb/taskpool.py
index 8bfcb3a345..7632c99937 100644
--- a/js/src/gdb/taskpool.py
+++ b/js/src/gdb/taskpool.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 import fcntl, os, select, time
 from subprocess import Popen, PIPE
 
@@ -68,7 +69,7 @@ class TaskPool(object):
     # Set self.next_pending to the next task that has not yet been executed.
     def get_next_pending(self):
         try:
-            return self.pending.next()
+            return next(self.pending)
         except StopIteration:
             return None
 
@@ -203,17 +204,17 @@ if __name__ == '__main__':
             def cmd(self):
                 return ['sh', '-c', 'echo out; sleep %d; echo err>&2' % (self.n,)]
             def onStdout(self, text):
-                print '%d stdout: %r' % (self.n, text)
+                print('%d stdout: %r' % (self.n, text))
             def onStderr(self, text):
-                print '%d stderr: %r' % (self.n, text)
+                print('%d stderr: %r' % (self.n, text))
             def onFinished(self, returncode):
-                print '%d (rc=%d)' % (self.n, returncode)
+                print('%d (rc=%d)' % (self.n, returncode))
                 sorted.append(self.n)
             def onTimeout(self):
-                print '%d timed out' % (self.n,)
+                print('%d timed out' % (self.n,))
 
         p = TaskPool([SortableTask(_) for _ in ns], job_limit=len(ns), timeout=timeout)
         p.run_all()
         return sorted
 
-    print repr(sleep_sort([1,1,2,3,5,8,13,21,34], 15))
+    print(repr(sleep_sort([1,1,2,3,5,8,13,21,34], 15)))
diff --git a/js/src/gdb/tests/test-unwind.py b/js/src/gdb/tests/test-unwind.py
index 6ddf0cd22b..deed741033 100644
--- a/js/src/gdb/tests/test-unwind.py
+++ b/js/src/gdb/tests/test-unwind.py
@@ -1,5 +1,6 @@
 # Test the unwinder and the frame filter.
 
+from __future__ import print_function
 import platform
 
 def do_unwinder_test():
@@ -21,7 +22,7 @@ def do_unwinder_test():
     found_outer = False
     frames = list(gdb.frames.execute_frame_filters(gdb.newest_frame(), 0, -1))
     for frame in frames:
-        print("examining " + frame.function())
+        print(("examining " + frame.function()))
         if first:
             assert_eq(frame.function().startswith("Something"), True)
             first = False
diff --git a/js/src/jit-test/jit_test.py b/js/src/jit-test/jit_test.py
index 084af2d4e5..9411d037cc 100755
--- a/js/src/jit-test/jit_test.py
+++ b/js/src/jit-test/jit_test.py
@@ -42,7 +42,7 @@ def choose_item(jobs, max_items, display):
     for i, job in enumerate(jobs, 1):
         print("{}) {}".format(i, display(job)))
 
-    item = raw_input('Which one:\n')
+    item = input('Which one:\n')
     try:
         item = int(item)
         if item > job_count or item < 1:
@@ -319,7 +319,7 @@ def main(argv):
             except Exception as e:
                 sys.exit(str(e))
         else:
-            tc = job_list.next()
+            tc = next(job_list)
 
         if options.debugger == 'gdb':
             debug_cmd = ['gdb', '--args']
diff --git a/js/src/jsautokw.py b/js/src/jsautokw.py
index fa4b872b52..5cef3d1fe7 100644
--- a/js/src/jsautokw.py
+++ b/js/src/jsautokw.py
@@ -80,14 +80,14 @@ def split_list_per_column(keyword_list, column):
         per_column = column_dict.setdefault(keyword[column], [])
         per_column.append(item)
 
-    return sorted(column_dict.items(), key=lambda (char, keyword): ord(char))
+    return sorted(list(column_dict.items()), key=lambda char_keyword: ord(char_keyword[0]))
 
 def generate_letter_switch(opt, unprocessed_columns, keyword_list,
                            columns=None):
     assert(len(keyword_list) != 0);
 
     if not columns:
-        columns = range(0, unprocessed_columns)
+        columns = list(range(0, unprocessed_columns))
 
     if len(keyword_list) == 1:
         index, keyword = keyword_list[0]
@@ -161,7 +161,7 @@ def split_list_per_length(keyword_list):
         per_length = length_dict.setdefault(len(keyword), [])
         per_length.append(item)
 
-    return sorted(length_dict.items(), key=lambda (length, keyword): length)
+    return sorted(list(length_dict.items()), key=lambda length_keyword: length_keyword[0])
 
 def generate_switch(opt, keyword_list):
     assert(len(keyword_list) != 0);
diff --git a/js/src/tests/compare_bench.py b/js/src/tests/compare_bench.py
index cfe9508cd4..012bd3e0ee 100644
--- a/js/src/tests/compare_bench.py
+++ b/js/src/tests/compare_bench.py
@@ -15,7 +15,7 @@ def avg(seq):
 
 def compare(current, baseline):
     percent_speedups = []
-    for key, current_result in current.iteritems():
+    for key, current_result in current.items():
         try:
             baseline_result = baseline[key]
         except KeyError:
diff --git a/js/src/tests/ecma_6/String/make-normalize-generateddata-input.py b/js/src/tests/ecma_6/String/make-normalize-generateddata-input.py
index c1983dbd18..4373c0e1ae 100644
--- a/js/src/tests/ecma_6/String/make-normalize-generateddata-input.py
+++ b/js/src/tests/ecma_6/String/make-normalize-generateddata-input.py
@@ -12,7 +12,7 @@ import re, sys
 
 sep_pat = re.compile(' +')
 def to_code_list(codes):
-    return '[' + ', '.join(map(lambda x: '0x{0}'.format(x), re.split(sep_pat, codes))) + ']'
+    return '[' + ', '.join(['0x{0}'.format(x) for x in re.split(sep_pat, codes)]) + ']'
 
 def convert(dir):
     ver_pat = re.compile('NormalizationTest-([0-9\.]+)\.txt')
diff --git a/js/src/tests/jstests.py b/js/src/tests/jstests.py
index 6cd92a5e01..26225fd513 100755
--- a/js/src/tests/jstests.py
+++ b/js/src/tests/jstests.py
@@ -170,7 +170,7 @@ def parse_args():
         op.error('missing JS_SHELL argument')
 
     # Valgrind, gdb, and rr are mutually exclusive.
-    if sum(map(lambda e: 1 if e else 0, [options.valgrind, options.debug, options.rr])) > 1:
+    if sum([1 if e else 0 for e in [options.valgrind, options.debug, options.rr]]) > 1:
         op.error("--valgrind, --debug, and --rr are mutually exclusive.")
 
     # Fill the debugger field, as needed.
diff --git a/js/src/tests/lib/jittests.py b/js/src/tests/lib/jittests.py
index 0a1d1537a3..44464fc29e 100755
--- a/js/src/tests/lib/jittests.py
+++ b/js/src/tests/lib/jittests.py
@@ -13,12 +13,12 @@ from collections import namedtuple
 import StringIO
 
 if sys.platform.startswith('linux') or sys.platform.startswith('darwin'):
-    from tasks_unix import run_all_tests
+    from .tasks_unix import run_all_tests
 else:
-    from tasks_win import run_all_tests
+    from .tasks_win import run_all_tests
 
-from progressbar import ProgressBar, NullProgressBar
-from results import TestOutput
+from .progressbar import ProgressBar, NullProgressBar
+from .results import TestOutput
 
 TESTS_LIB_DIR = os.path.dirname(os.path.abspath(__file__))
 JS_DIR = os.path.dirname(os.path.dirname(TESTS_LIB_DIR))
@@ -567,7 +567,7 @@ def process_test_results(results, num_tests, pb, options):
                 sys.stdout.write(res.err)
 
             if options.check_output:
-                if res.test.path in output_dict.keys():
+                if res.test.path in list(output_dict.keys()):
                     if output_dict[res.test.path] != res.out:
                         pb.message("FAIL - OUTPUT DIFFERS {}".format(res.test.relpath_tests))
                 else:
@@ -623,7 +623,7 @@ def get_remote_results(tests, device, prefix, options):
     from mozdevice import devicemanager
 
     try:
-        for i in xrange(0, options.repeat):
+        for i in range(0, options.repeat):
             for test in tests:
                 yield run_test_remote(test, device, prefix, options)
     except devicemanager.DMError as e:
diff --git a/js/src/tests/lib/manifest.py b/js/src/tests/lib/manifest.py
index 7079a186f6..f4a18b05ff 100644
--- a/js/src/tests/lib/manifest.py
+++ b/js/src/tests/lib/manifest.py
@@ -7,7 +7,7 @@ from __future__ import print_function
 import os, re, sys
 from subprocess import Popen, PIPE
 
-from tests import RefTestCase
+from .tests import RefTestCase
 
 
 def split_path_into_dirs(path):
@@ -199,7 +199,7 @@ def _emit_manifest_at(location, relative, test_gen, depth):
     filename = os.path.join(location, 'jstests.list')
     manifest = []
     numTestFiles = 0
-    for k, test_list in manifests.iteritems():
+    for k, test_list in manifests.items():
         fullpath = os.path.join(location, k)
         if os.path.isdir(fullpath):
             manifest.append("include " + k + "/jstests.list")
